#include <cstdio>
#include <iostream>
#include <cmath>
#include <cstring>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

vector <pair <int, pair<int, int> > > calls;
vector <pair <int, int> > ans; ///number time

void ans_print(){
sort(ans.begin(), ans.end());
while(!ans.empty()){
    cout <<ans[0].second <<endl;
    ans.erase(ans.begin());
}
exit(0);
}

int call_process(pair<int, int> st){
    bool flag = true;
    int j = 0;
    while(flag){
        if(calls[j].first >= st.first + st.second) break;

        if((calls[j].second.second <= st.second) && (st.first + st.second - calls[j].second.second >= calls[j].first)){
            //cout <<"Person number " <<calls[j].second.first <<" taken from floor " <<calls[j].second.second <<" at moment " <<st.first + st.second - calls[j].second.second <<endl;
            ans.push_back(make_pair(calls[j].second.first, st.second + st.first - 1));
            calls.erase(calls.begin()+j);
            if(calls.empty()) ans_print();
        }
        else j++;
    }
    return (st.second + st.first - 1);
}

pair<int, int> call_await(int moment){
    //cout <<"Moment: " <<moment <<endl;
    if(calls.empty()) ans_print();
    //cout <<"Activating call to floor " <<calls[0].second.second <<" at moment " <<max(moment, calls[0].first) <<endl;
    return call_await(call_process(make_pair(max(moment, calls[0].first) + calls[0].second.second - 1, calls[0].second.second)));
}

int main()
{
    int n, m, trs1, trs2;
    cin >>n >>m;
    for(int i = 0; i < n; i++){
        cin >>trs1 >>trs2;
        calls.push_back(make_pair(trs1, make_pair(i, trs2))); ///time number floor
    }
    sort(calls.begin(), calls.end());
    call_await(0);
    return 0;
}
