#include <cstdio>
#include <iostream>
#include <cmath>
#include <cstring>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

int main()
{
    int n, m, steps, parent, ilen, jlen;
    cin >>n;
    cin >>m;
    int p[n+1];
    vector<int> path[n+1];
    for(int i = 2; i <= n; i++) cin >>p[i];

    for(int i = 2; i <= n; i++)
    {
        parent = p[i];
        path[i].push_back(i);
        while(parent != 1)
        {
            path[i].push_back(parent);
            parent = p[parent];
        }
    }

    /*for(int i = 2; i <= n; i++)
    {
        cout <<i <<" - ";
        for(int j = 0; j < path[i].size(); j++) cout <<path[i][j] <<' ';
        cout <<endl;
    }*/

    int mx = 0, work;
    for(int i = 1; i <= n; i++) for(int j = 1; j <= n; j++) if(j != i)
    {
        ilen = path[i].size();
        jlen = path[j].size();
        work = jlen + ilen;
        //cout <<"path between " <<i <<" and " <<j <<" equals to " <<work;
        while((ilen>0) && (jlen>0) && (path[i][ilen-1] == path[j][jlen-1])){
            work-=2;
            //cout <<"-2";
            ilen--;
            jlen--;
        }
        //cout <<" and is " <<work <<endl;
        mx = max(mx, work);
    }

    cout <<mx+1;
    return 0;
}
