#include <cstdio>
#include <iostream>
#include <cmath>
#include <cstring>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

int main()
{
    int n, m, steps, parent, ilen, jlen;
    cin >>n;
    cin >>m;
    int p[n+1];
    vector<int> path[n+1];
    vector<int> lst;
    for(int i = 2; i <= n; i++) cin >>p[i];

    for(int i = 2; i <= n; i++)
    {
        parent = p[i];
        path[i].push_back(i);
        while(parent != 1)
        {
            path[i].push_back(parent);
            parent = p[parent];
        }
    }
    lst.push_back(1);
    for(int i = 2; i <= n; i++)
    {
        bool flag = true;
        for(int j = 2; j <= n; j++) if(i == p[j])
        {
            flag = false;
            break;
        }
        if(flag) lst.push_back(i);
    }

    /*for(int i = 2; i <= n; i++)
    {
        cout <<i <<" - ";
        for(int j = 0; j < path[i].size(); j++) cout <<path[i][j] <<' ';
        cout <<endl;
    }*/

    int mx = 0, work;
    for(int i = 0; i < lst.size(); i++) for(int j = 0; j < lst.size(); j++) if(lst[j] != lst[i])
            {
                ilen = path[lst[i]].size();
                jlen = path[lst[j]].size();
                work = jlen + ilen;
                //cout <<"path between " <<lst[i] <<" and " <<lst[j] <<" equals to " <<work;
                while((ilen>0) && (jlen>0) && (path[lst[i]][ilen-1] == path[lst[j]][jlen-1]))
                {
                    work-=2;
                    //cout <<"-2";
                    ilen--;
                    jlen--;
                }
                //cout <<" and is " <<work <<endl;
                mx = max(mx, work);
            }

    cout <<mx+1;
    return 0;
}
