#include <cstdio>
#include <iostream>
#include <cmath>
#include <cstring>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

vector<pair<int, int> > lens;

void len_cnt(int cur_pow, int cur_vrt, vector<int>* gr)
{
    lens.push_back(make_pair(cur_vrt, cur_pow));
    for(int i = 0; i < gr[cur_vrt].size(); i++) len_cnt(cur_pow+1, gr[cur_vrt][i], gr);
}

int main()
{
    int n, m, steps, parent;
    cin >>n;
    cin >>m;
    int p[n+1];
    vector<int> gr[n+1];
    for(int i = 2; i <= n; i++)
    {
        cin >>p[i];
        gr[p[i]].push_back(i);
    }

    len_cnt(0, 1, gr);

    /*for(int i = 1; i <= n; i++)
    {
        cout <<i <<" - ";
        for(int j = 0; j < gr[i].size(); j++) cout <<gr[i][j] <<' ';
        cout <<endl;
    }*/
    sort(lens.begin(), lens.end());
    for(int i = 0; i < n; i++) cout <<lens[i].first <<" - " <<lens[i].second <<endl;
    int mx = 0;
    for(int i = 0; i < n; i++) for(int j = 0; j < n; j++) if(i != j) mx = max(mx, lens[i].second + lens[j].second);
    cout <<mx + 1;
    return 0;
}
